# Groups
Groups are a way of building communities of people together on Treadl. A group can contain any number of people and projects. They can include discussion boards (e.g. for talking about projects, weaving, or for arranging meetings) and a directory to allow members to see who else is a member of their group.

Groups might be useful for the following purposes:

* General interest (e.g. around particular topics)
* Forums
* Teaching groups
* Guild groups
* Weaving groups
* ... and much more!

Groups are configurable and can be open or **closed**. That means you can have a group that anyone can find and join, or a group that is kept private, and to which other people must be invited to join.

In this article we will discuss groups in more detail and explain how some of the key concepts work.

## Creating a new group
Any Treadl user can create a new group. To do so, find the **Groups** area on your homepage (when logged-in) and click the **Create a new group** button.

![Finding the create group button](/images/docs/groups1.png)

A screen like the following will then display:

![The new group page](/images/docs/groups2.png)

On this page you can:

* **Name your group**: A short but meaningful name for your group (e.g. "Hogwarts Weaving Class 2022" or "Double Weave Forum").
* **Describe your group**: Add additional longer text to describe your group in more detail.
* **Choose whether your group is closed or not**: Closed groups mean you will need to invite others or approve join requests yourself.

Please note that all of this information can later be changed at any time.

When you are ready, click the **Create group** button to complete the creation process.

You'll then be taken to your new group, and you will notice that you are the only member.

![A new empty group](/images/docs/groups3.png)

## A tour around your group
In this section we describe the different areas of your group. These areas can be found using the tabs shown on the left-hand side.

### The Noticeboard
The **Noticeboard** is a place for you and other members to post updates and discussions. It is a way for people to communicate. Users can reply to each others' posts, include attachments (like files or images) and even attach their projects.

![The group Noticeboard](/images/docs/groups4.png)

### Members
The **Members** tab lists the current members of your group. If you are a group administrator, you are shown how to invite other people to join your group.

### Projects
The **Projects** tab lists the *projects* that have been made visible to this group. Projects can be made visible to the group from the projects' settings page, or directly from this tab by clicking the **Add one of your own projects** button.

![The group Projects tab](/images/docs/groups5.png)

### Settings
The **Settings** tab will only show for users that are admins of the group. On this tab you can change the settings of the group and also delete your group.

![The group Settings tab](/images/docs/groups6.png)

## Deleting a group
A group can be deleted (or "disbanded") by finding the **Settings** tab of your group, and then clicking the **Delete group** button.

![Deleting a group](/images/docs/groups7.png)

**Please note that you can only access the settings page of a group if you are an admin for the group.**

Deleting a group does not delete the users or projects it contains.

## Discovering your group
If your group is **not closed**, then other members can find your group from the search bar.

In the example below, a user "Alice" has searched for our "Test group" and pressed the enter key. The group is shown.

![Searching for a group](/images/docs/groups8.png)

Alternatively, you can send them a link to your group. To find the link, go to the **Members** tab of your group and find the share link. This can be copied to your clipboard using the button, as shown below.

![Finding the group link](/images/docs/groups9.png)

This link can then be shared with someone (e.g. via email or Whatsapp) to allow them to discover your group.

Whether the user has found your group via search, or if they have followed a link you have sent them, they will see a screen that looks like the following. The user can join the group by clicking the **Join group** button.

![Viewing the group as a non-member](/images/docs/groups10.png)

Once the user has joined the group, they will be able to view and post on the Noticeboard.

## Inviting others to your group
If your group is **closed**, users cannot discover your group. Instead, you will need to **invite them** to join.

**Important: you can only invite people that are already have an account on Treadl. If you want to invite someone who isn't yet on Treadl, ask them to register first.**

To invite someone to join, find the **search bar** on the **Members** tab of your group. Please note you need to be a group admin to invite others.

![Finding the group invite member search bar](/images/docs/groups11.png)

Type the user's username into the group. As you type, Treadl will suggest users to you. When the desired user has been listed, you can click their username to add them to the group.

![Searching for a new member](/images/docs/groups12.png)

Once they have been invited, the prospective member will receive an email notification and the invite will also appear on their homepage (as shown in the section below).

Until the prospective member accepts your invitation, they will show as "invited" in your group's member list.

![The group member list, showing an invited user](/images/docs/groups13.png)

From here you can also delete the invitation, which revokes it.

## Accepting an invitation to join a group
If you have received an invitation to join a group, you will receive an email (if your notification preferences are set accordingly) and the invitation will also be shown on your homepage.

![Pending invitations on the homepage](/images/docs/groups14.png)

If you **choose to accept** the invitation, you will be added to the group. You can then view other members and participate in the group's Noticeboard.

If you **choose to decline** the invitation, the invite will be deleted. You will not be added to the group.

## Removing a member from your group
As a group admin, you can remove other people from your group.

To do so, identify the user on the **Members** tab of your group, and click the **Kick** option in the **Options** dropdown. This is demonstrated in the image below.

![Kicking a user from the group](/images/docs/groups15.png)

The member will be immediately removed, and will no longer have access to the group member list or noticeboard.

**Please note: if your group is not closed, the user will be able to simply re-join again.**