import { Segment } from 'semantic-ui-react'
import { Link as RouterLink } from 'react-router-dom'
import styled from 'styled-components'
import BugImage from '../../images/warning.png'

import utils from '../../utils/utils'

const StyledErrorElement = styled.div`
  img {  
    max-width: 300px;
  }
`

export default function ErrorElement () {
  return (
    <Segment textAlign='center'>
      <StyledErrorElement>
        <div>
          <img src={BugImage} alt='Application issue' />
        </div>
        <h2>{utils.appName()} has encountered an error</h2>
        <p>We are sorry, but there was a problem when showing this part of the app.</p>
        <p>You can try to <RouterLink to='/' color='blue.500'>return to the home page</RouterLink>.</p>
      </StyledErrorElement>
    </Segment>
  )
}
