import React from 'react'
import styled from 'styled-components'
import { Link } from 'react-router-dom'

export const LinkContainer = styled.span`
  display: inline-block;
  border: 1px solid rgb(240,240,240);
  border-radius: 5px;
  padding: 5px;
  ${p => p.marginTop ? 'margin-top: 10px;' : ''}
  ${p => p.marginLeft ? 'margin-left: 10px;' : ''}
  ${p => p.marginBottom ? 'margin-bottom: 10px;' : ''}
  color: #1e70bf;
  .emoji{
    margin-right: 5px;
  }
`
function ReportLink ({ className, text, referrer, marginTop, marginLeft, marginBottom, style }) {
  return (
    <LinkContainer style={style} marginTop={marginTop} marginLeft={marginLeft} marginBottom={marginBottom}>
      <Link to={`/report?referrer=${referrer}`} className={className}>
        <span className='emoji'>📢</span>
        {text || 'Report'}
      </Link>
    </LinkContainer>
  )
}

export default ReportLink
